# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GenerativefirewallValidateResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scan_types': 'list[GenerativefirewallValidationType]',
        'flagged_scan_types': 'list[GenerativefirewallValidationType]',
        'flagged_input_rules': 'list[str]',
        'flagged_output_rules': 'list[str]',
        'allowed_input_rules': 'list[str]',
        'allowed_output_rules': 'list[str]',
        'vendor_name': 'str',
        'product': 'str',
        'firewall_instance_id': 'RimeUUID',
        'version': 'str',
        'schema_version': 'str',
        'request': 'ValidateResponseProcessedRequest',
        'scanned_time': 'datetime',
        'trace_id': 'RimeUUID',
        'input_results': 'dict(str, GenerativefirewallRuleDetails)',
        'output_results': 'dict(str, GenerativefirewallRuleDetails)'
    }

    attribute_map = {
        'scan_types': 'scanTypes',
        'flagged_scan_types': 'flaggedScanTypes',
        'flagged_input_rules': 'flaggedInputRules',
        'flagged_output_rules': 'flaggedOutputRules',
        'allowed_input_rules': 'allowedInputRules',
        'allowed_output_rules': 'allowedOutputRules',
        'vendor_name': 'vendorName',
        'product': 'product',
        'firewall_instance_id': 'firewallInstanceId',
        'version': 'version',
        'schema_version': 'schemaVersion',
        'request': 'request',
        'scanned_time': 'scannedTime',
        'trace_id': 'traceId',
        'input_results': 'inputResults',
        'output_results': 'outputResults'
    }

    def __init__(self, scan_types=None, flagged_scan_types=None, flagged_input_rules=None, flagged_output_rules=None, allowed_input_rules=None, allowed_output_rules=None, vendor_name=None, product=None, firewall_instance_id=None, version=None, schema_version=None, request=None, scanned_time=None, trace_id=None, input_results=None, output_results=None):  # noqa: E501
        """GenerativefirewallValidateResponse - a model defined in Swagger"""  # noqa: E501
        self._scan_types = None
        self._flagged_scan_types = None
        self._flagged_input_rules = None
        self._flagged_output_rules = None
        self._allowed_input_rules = None
        self._allowed_output_rules = None
        self._vendor_name = None
        self._product = None
        self._firewall_instance_id = None
        self._version = None
        self._schema_version = None
        self._request = None
        self._scanned_time = None
        self._trace_id = None
        self._input_results = None
        self._output_results = None
        self.discriminator = None
        if scan_types is not None:
            self.scan_types = scan_types
        if flagged_scan_types is not None:
            self.flagged_scan_types = flagged_scan_types
        if flagged_input_rules is not None:
            self.flagged_input_rules = flagged_input_rules
        if flagged_output_rules is not None:
            self.flagged_output_rules = flagged_output_rules
        if allowed_input_rules is not None:
            self.allowed_input_rules = allowed_input_rules
        if allowed_output_rules is not None:
            self.allowed_output_rules = allowed_output_rules
        if vendor_name is not None:
            self.vendor_name = vendor_name
        if product is not None:
            self.product = product
        if firewall_instance_id is not None:
            self.firewall_instance_id = firewall_instance_id
        if version is not None:
            self.version = version
        if schema_version is not None:
            self.schema_version = schema_version
        if request is not None:
            self.request = request
        if scanned_time is not None:
            self.scanned_time = scanned_time
        if trace_id is not None:
            self.trace_id = trace_id
        if input_results is not None:
            self.input_results = input_results
        if output_results is not None:
            self.output_results = output_results

    @property
    def scan_types(self):
        """Gets the scan_types of this GenerativefirewallValidateResponse.  # noqa: E501

        Lists what was scanned- the input, the output, or both.  # noqa: E501

        :return: The scan_types of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: list[GenerativefirewallValidationType]
        """
        return self._scan_types

    @scan_types.setter
    def scan_types(self, scan_types):
        """Sets the scan_types of this GenerativefirewallValidateResponse.

        Lists what was scanned- the input, the output, or both.  # noqa: E501

        :param scan_types: The scan_types of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: list[GenerativefirewallValidationType]
        """

        self._scan_types = scan_types

    @property
    def flagged_scan_types(self):
        """Gets the flagged_scan_types of this GenerativefirewallValidateResponse.  # noqa: E501

        Lists what was flagged- the input, the output, or both. This is always a subset of scan_types.  # noqa: E501

        :return: The flagged_scan_types of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: list[GenerativefirewallValidationType]
        """
        return self._flagged_scan_types

    @flagged_scan_types.setter
    def flagged_scan_types(self, flagged_scan_types):
        """Sets the flagged_scan_types of this GenerativefirewallValidateResponse.

        Lists what was flagged- the input, the output, or both. This is always a subset of scan_types.  # noqa: E501

        :param flagged_scan_types: The flagged_scan_types of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: list[GenerativefirewallValidationType]
        """

        self._flagged_scan_types = flagged_scan_types

    @property
    def flagged_input_rules(self):
        """Gets the flagged_input_rules of this GenerativefirewallValidateResponse.  # noqa: E501

        Complete list of all rules that flagged the input.  # noqa: E501

        :return: The flagged_input_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._flagged_input_rules

    @flagged_input_rules.setter
    def flagged_input_rules(self, flagged_input_rules):
        """Sets the flagged_input_rules of this GenerativefirewallValidateResponse.

        Complete list of all rules that flagged the input.  # noqa: E501

        :param flagged_input_rules: The flagged_input_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: list[str]
        """

        self._flagged_input_rules = flagged_input_rules

    @property
    def flagged_output_rules(self):
        """Gets the flagged_output_rules of this GenerativefirewallValidateResponse.  # noqa: E501

        Complete list of all rules that flagged the output.  # noqa: E501

        :return: The flagged_output_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._flagged_output_rules

    @flagged_output_rules.setter
    def flagged_output_rules(self, flagged_output_rules):
        """Sets the flagged_output_rules of this GenerativefirewallValidateResponse.

        Complete list of all rules that flagged the output.  # noqa: E501

        :param flagged_output_rules: The flagged_output_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: list[str]
        """

        self._flagged_output_rules = flagged_output_rules

    @property
    def allowed_input_rules(self):
        """Gets the allowed_input_rules of this GenerativefirewallValidateResponse.  # noqa: E501

        Complete list of all rules that allowed the input.  # noqa: E501

        :return: The allowed_input_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_input_rules

    @allowed_input_rules.setter
    def allowed_input_rules(self, allowed_input_rules):
        """Sets the allowed_input_rules of this GenerativefirewallValidateResponse.

        Complete list of all rules that allowed the input.  # noqa: E501

        :param allowed_input_rules: The allowed_input_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: list[str]
        """

        self._allowed_input_rules = allowed_input_rules

    @property
    def allowed_output_rules(self):
        """Gets the allowed_output_rules of this GenerativefirewallValidateResponse.  # noqa: E501

        Complete list of all rules that allowed the output.  # noqa: E501

        :return: The allowed_output_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_output_rules

    @allowed_output_rules.setter
    def allowed_output_rules(self, allowed_output_rules):
        """Sets the allowed_output_rules of this GenerativefirewallValidateResponse.

        Complete list of all rules that allowed the output.  # noqa: E501

        :param allowed_output_rules: The allowed_output_rules of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: list[str]
        """

        self._allowed_output_rules = allowed_output_rules

    @property
    def vendor_name(self):
        """Gets the vendor_name of this GenerativefirewallValidateResponse.  # noqa: E501

        The name of the entity that manages the Firewall Instance.  # noqa: E501

        :return: The vendor_name of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: str
        """
        return self._vendor_name

    @vendor_name.setter
    def vendor_name(self, vendor_name):
        """Sets the vendor_name of this GenerativefirewallValidateResponse.

        The name of the entity that manages the Firewall Instance.  # noqa: E501

        :param vendor_name: The vendor_name of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: str
        """

        self._vendor_name = vendor_name

    @property
    def product(self):
        """Gets the product of this GenerativefirewallValidateResponse.  # noqa: E501

        The name of the product that is processing this request.  # noqa: E501

        :return: The product of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: str
        """
        return self._product

    @product.setter
    def product(self, product):
        """Sets the product of this GenerativefirewallValidateResponse.

        The name of the product that is processing this request.  # noqa: E501

        :param product: The product of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: str
        """

        self._product = product

    @property
    def firewall_instance_id(self):
        """Gets the firewall_instance_id of this GenerativefirewallValidateResponse.  # noqa: E501


        :return: The firewall_instance_id of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: RimeUUID
        """
        return self._firewall_instance_id

    @firewall_instance_id.setter
    def firewall_instance_id(self, firewall_instance_id):
        """Sets the firewall_instance_id of this GenerativefirewallValidateResponse.


        :param firewall_instance_id: The firewall_instance_id of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: RimeUUID
        """

        self._firewall_instance_id = firewall_instance_id

    @property
    def version(self):
        """Gets the version of this GenerativefirewallValidateResponse.  # noqa: E501

        Firewall semantic version.  # noqa: E501

        :return: The version of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this GenerativefirewallValidateResponse.

        Firewall semantic version.  # noqa: E501

        :param version: The version of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def schema_version(self):
        """Gets the schema_version of this GenerativefirewallValidateResponse.  # noqa: E501

        API schema version is the version of the API response. This should be updated whenever we make semantic changes to the response.  # noqa: E501

        :return: The schema_version of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: str
        """
        return self._schema_version

    @schema_version.setter
    def schema_version(self, schema_version):
        """Sets the schema_version of this GenerativefirewallValidateResponse.

        API schema version is the version of the API response. This should be updated whenever we make semantic changes to the response.  # noqa: E501

        :param schema_version: The schema_version of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: str
        """

        self._schema_version = schema_version

    @property
    def request(self):
        """Gets the request of this GenerativefirewallValidateResponse.  # noqa: E501


        :return: The request of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: ValidateResponseProcessedRequest
        """
        return self._request

    @request.setter
    def request(self, request):
        """Sets the request of this GenerativefirewallValidateResponse.


        :param request: The request of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: ValidateResponseProcessedRequest
        """

        self._request = request

    @property
    def scanned_time(self):
        """Gets the scanned_time of this GenerativefirewallValidateResponse.  # noqa: E501

        Date and time at which the Firewall allowed or denied this request.  # noqa: E501

        :return: The scanned_time of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._scanned_time

    @scanned_time.setter
    def scanned_time(self, scanned_time):
        """Sets the scanned_time of this GenerativefirewallValidateResponse.

        Date and time at which the Firewall allowed or denied this request.  # noqa: E501

        :param scanned_time: The scanned_time of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: datetime
        """

        self._scanned_time = scanned_time

    @property
    def trace_id(self):
        """Gets the trace_id of this GenerativefirewallValidateResponse.  # noqa: E501


        :return: The trace_id of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: RimeUUID
        """
        return self._trace_id

    @trace_id.setter
    def trace_id(self, trace_id):
        """Sets the trace_id of this GenerativefirewallValidateResponse.


        :param trace_id: The trace_id of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: RimeUUID
        """

        self._trace_id = trace_id

    @property
    def input_results(self):
        """Gets the input_results of this GenerativefirewallValidateResponse.  # noqa: E501

        Succinct results of the Firewall for model input. The key is a rule name.  # noqa: E501

        :return: The input_results of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: dict(str, GenerativefirewallRuleDetails)
        """
        return self._input_results

    @input_results.setter
    def input_results(self, input_results):
        """Sets the input_results of this GenerativefirewallValidateResponse.

        Succinct results of the Firewall for model input. The key is a rule name.  # noqa: E501

        :param input_results: The input_results of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: dict(str, GenerativefirewallRuleDetails)
        """

        self._input_results = input_results

    @property
    def output_results(self):
        """Gets the output_results of this GenerativefirewallValidateResponse.  # noqa: E501

        Succinct results of the Firewall for model output. The key is a rule name.  # noqa: E501

        :return: The output_results of this GenerativefirewallValidateResponse.  # noqa: E501
        :rtype: dict(str, GenerativefirewallRuleDetails)
        """
        return self._output_results

    @output_results.setter
    def output_results(self, output_results):
        """Sets the output_results of this GenerativefirewallValidateResponse.

        Succinct results of the Firewall for model output. The key is a rule name.  # noqa: E501

        :param output_results: The output_results of this GenerativefirewallValidateResponse.  # noqa: E501
        :type: dict(str, GenerativefirewallRuleDetails)
        """

        self._output_results = output_results

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerativefirewallValidateResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerativefirewallValidateResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
